<template>
  <div class="p-sm-2">
    <div class="my-3 pb-2">
      <div class="d-flex justify-content-between align-items-center">
        <div class="d-flex justify-content-start align-items-center">
          <img
            style="height: auto; width: 12vw; max-width: 100px"
            class="me-2 me-sm-3"
            src="@/assets/icon-app-bitcoin.svg"
          />
          <div>
            <svg
              width="8"
              height="8"
              viewBox="0 0 8 8"
              fill="none"
              xmlns="http://www.w3.org/2000/svg"
            >
              <circle cx="4" cy="4" r="4" fill="#00CD98" />
            </svg>
            <small class="ms-1 text-success">Running</small>
            <h3 class="d-block font-weight-bold mb-1">Bitcoin</h3>
            <span v-if="knotsVersion" class="d-block text-muted"
              >Bitcoin Knots {{ knotsVersion }} (Based on Bitcoin Core
              {{ coreVersion }})</span
            >
            <span v-else class="d-block text-muted"
              >Bitcoin Core {{ coreVersion }}</span
            >
          </div>
        </div>
      </div>
    </div>

    <b-row class="row-eq-height">
      <b-col col cols="12" md="6" xl="4">
        <bitcoin-wallet></bitcoin-wallet>
      </b-col>
      <b-col col cols="12" md="6" xl="4">
        <card-widget
          header="Blockchain"
          :loading="
            bitcoinStore.percent !== 100 || bitcoinStore.blocks.length === 0
          "
        >
          <div class>
            <div class="px-3 px-lg-4 mb-3">
              <div class="w-100 d-flex justify-content-between mb-2">
                <span class="align-self-end">Synchronized</span>
                <h3 class="font-weight-normal mb-0">
                  <span v-if="bitcoinStore.percent !== -1">
                    {{
                      bitcoinStore.percent >= 99.99
                        ? 100
                        : round(bitcoinStore.percent)
                    }}
                    <small class>%</small>
                  </span>

                  <span
                    v-else
                    class="loading-placeholder loading-placeholder-lg d-block"
                    style="width: 6rem"
                  ></span>
                </h3>
              </div>
              <b-progress
                :value="Math.round(bitcoinStore.percent)"
                class="mb-1"
                variant="success"
                :style="{ height: '4px' }"
                animated
                striped
              ></b-progress>
              <small
                v-if="bitcoinStore.currentBlock < bitcoinStore.blockHeight - 1"
                class="text-muted d-block text-end"
              >
                {{ bitcoinStore.currentBlock.toLocaleString() }} of
                {{ bitcoinStore.blockHeight.toLocaleString() }} blocks
                <b-icon-info-circle-fill
                  v-tooltip.bottom="t('bitcoin.sync-info')"
                  icon="info-circle-fill"
                  style="opacity: 0.4"
                  variant="dark"
                  class="ms-1"
                />
              </small>
            </div>
            <p class="px-3 px-lg-4 mb-3">Latest Blocks</p>
            <blockchain :num-blocks="3"></blockchain>
            <div class="px-3 px-lg-4 py-2"></div>
          </div>
        </card-widget>
      </b-col>
      <b-col col cols="12" xl="4">
        <card-widget header="Network">
          <div class>
            <div class="px-3 px-lg-4 pb-2">
              <b-row>
                <b-col col cols="6" md="3" xl="6">
                  <stat
                    title="Connections"
                    :value="bitcoinStore.stats.peers"
                    suffix="Peers"
                    show-numeric-change
                  ></stat>
                </b-col>
                <b-col col cols="6" md="3" xl="6">
                  <stat
                    title="Mempool"
                    :value="abbreviateSize(bitcoinStore.stats.mempool)[0]"
                    :suffix="abbreviateSize(bitcoinStore.stats.mempool)[1]"
                    show-percent-change
                  ></stat>
                </b-col>
                <b-col col cols="6" md="3" xl="6">
                  <stat
                    title="Hashrate"
                    :value="abbreviateHashRate(bitcoinStore.stats.hashrate)[0]"
                    :suffix="abbreviateHashRate(bitcoinStore.stats.hashrate)[1]"
                    show-percent-change
                  ></stat>
                </b-col>
                <b-col col cols="6" md="3" xl="6">
                  <stat
                    title="Blockchain Size"
                    :value="
                      abbreviateSize(bitcoinStore.stats.blockchainSize)[0]
                    "
                    :suffix="
                      abbreviateSize(bitcoinStore.stats.blockchainSize)[1]
                    "
                    show-percent-change
                  ></stat>
                </b-col>
              </b-row>
            </div>
          </div>
        </card-widget>
      </b-col>
    </b-row>
  </div>
</template>

<script lang="ts" setup>
import { ref, computed, onMounted, onBeforeUnmount } from "vue";
import { useI18n } from "vue-i18n";
import { BIconInfoCircleFill } from "bootstrap-icons-vue";
import CardWidget from "@/components/CardWidget.vue";
import Blockchain from "@/components/Blockchain.vue";
import Stat from "@/components/Utility/Stat.vue";
import BitcoinWallet from "@/components/BitcoinWallet.vue";
import useBitcoinStore from "@/store/bitcoin";

const { t } = useI18n();
const bitcoinStore = useBitcoinStore();

const interval = ref<null | number>(null);

const coreVersion = computed(() => {
  return bitcoinStore.version.split("/")[1]?.split(":")[1];
});
const knotsVersion = computed(() => {
  return bitcoinStore.version.split("/")[2]?.split(":")[1];
});
onMounted(() => {
  bitcoinStore.getVersion();
  fetchStats();
  interval.value = window.setInterval(fetchStats, 5000);
});
onBeforeUnmount(() => {
  window.clearInterval(interval.value!);
});
function abbreviateHashRate(n: number): [number, string] {
  if (n < 1e3) return [Number(n.toFixed(1)), "H/s"];
  if (n >= 1e3 && n < 1e6) return [Number((n / 1e3).toFixed(1)), "kH/s"];
  if (n >= 1e6 && n < 1e9) return [Number((n / 1e6).toFixed(1)), "MH/s"];
  if (n >= 1e9 && n < 1e12) return [Number((n / 1e9).toFixed(1)), "GH/s"];
  if (n >= 1e12 && n < 1e15) return [Number((n / 1e12).toFixed(1)), "TH/s"];
  if (n >= 1e15 && n < 1e18) return [Number((n / 1e15).toFixed(1)), "PH/s"];
  if (n >= 1e18 && n < 1e21) return [Number((n / 1e18).toFixed(1)), "EH/s"];
  if (n >= 1e21) return [Number(+(n / 1e21).toFixed(1)), "ZH/s"];
  // Just a fallback to prevent TS errors
  return [Number(n.toFixed(1)), "H/s"];
}
function abbreviateSize(n: number): [number, string] {
  if (n < 1e3) return [Number(n.toFixed(1)), "Bytes"];
  if (n >= 1e3 && n < 1e6) return [Number((n / 1e3).toFixed(1)), "KB"];
  if (n >= 1e6 && n < 1e9) return [Number((n / 1e6).toFixed(1)), "MB"];
  if (n >= 1e9 && n < 1e12) return [Number((n / 1e9).toFixed(1)), "GB"];
  if (n >= 1e12 && n < 1e15) return [Number((n / 1e12).toFixed(1)), "TB"];
  if (n >= 1e15) return [Number(+(n / 1e15).toFixed(1)), "PB"];
  // Just a fallback to prevent TS errors
  return [Number(n.toFixed(1)), "Bytes"];
}
function fetchStats() {
  bitcoinStore.getStats();
}

definePageMeta({
  layout: "authenticated",
  pageTransition: { name: "change-page", mode: "out-in" },
});

function round(n: number) {
  return Math.round(n * 100) / 100;
}
</script>
